Index: frontends/php/include/nodes.inc.php
===================================================================
--- frontends/php/include/nodes.inc.php	(revision 38884)
+++ frontends/php/include/nodes.inc.php	(working copy)
@@ -30,7 +30,7 @@
 		foreach($nodeids as $nodeid){
 			$profileid = get_dbid('profiles', 'profileid');
 			$sql='INSERT INTO profiles (profileid, userid, idx, value_id, type)'.
-				' VALUES ('.$profileid.','.$USER_DETAILS['userid'].', '.zbx_dbstr('web.nodes.selected').','.$nodeid.', 4)';
+				' VALUES ('.$profileid.','.$USER_DETAILS['userid'].', '.zbx_dbstr('web.nodes.selected').','.zbx_dbstr($nodeid).', 4)';
 			DBexecute($sql);
 		}
 
@@ -288,19 +288,19 @@
 		}
 
 
-		if(DBfetch(DBselect('SELECT nodeid FROM nodes WHERE nodeid='.$new_nodeid))){
+		if(DBfetch(DBselect('SELECT nodeid FROM nodes WHERE nodeid='.zbx_dbstr($new_nodeid)))){
 			error(S_NODE_WITH_SAME_ID_ALREADY_EXISTS);
 			return false;
 		}
 
 		$nodetype = 0;
 		$sql = 'INSERT INTO nodes (nodeid,name,timezone,ip,port,slave_history,slave_trends, nodetype,masterid) '.
-			' VALUES ('.$new_nodeid.','.zbx_dbstr($name).','.$timezone.','.zbx_dbstr($ip).','.$port.','.$slave_history.','.
-			$slave_trends.','.$nodetype.','.$masterid.')';
+			' VALUES ('.zbx_dbstr($new_nodeid).','.zbx_dbstr($name).','.zbx_dbstr($timezone).','.zbx_dbstr($ip).','.zbx_dbstr($port).','.zbx_dbstr($slave_history).','.
+			zbx_dbstr($slave_trends).','.zbx_dbstr($nodetype).','.zbx_dbstr($masterid).')';
 		$result = DBexecute($sql);
 
 		if($result && $node_type == ZBX_NODE_MASTER){
-			DBexecute('UPDATE nodes SET masterid='.$new_nodeid.' WHERE nodeid='.$ZBX_LOCALNODEID);
+			DBexecute('UPDATE nodes SET masterid='.zbx_dbstr($new_nodeid).' WHERE nodeid='.$ZBX_LOCALNODEID);
 			$ZBX_CURMASTERID = $new_nodeid; /* apply Master node for this script */
 		}
 
@@ -314,16 +314,16 @@
 			return false;
 		}
 
-		$result = DBexecute('UPDATE nodes SET nodeid='.$new_nodeid.',name='.zbx_dbstr($name).','.
-			'timezone='.$timezone.',ip='.zbx_dbstr($ip).',port='.$port.','.
-			'slave_history='.$slave_history.',slave_trends='.$slave_trends.
-			' WHERE nodeid='.$nodeid);
+		$result = DBexecute('UPDATE nodes SET nodeid='.zbx_dbstr($new_nodeid).',name='.zbx_dbstr($name).','.
+			'timezone='.zbx_dbstr($timezone).',ip='.zbx_dbstr($ip).',port='.zbx_dbstr($port).','.
+			'slave_history='.zbx_dbstr($slave_history).',slave_trends='.zbx_dbstr($slave_trends).
+			' WHERE nodeid='.zbx_dbstr($nodeid));
 	return $result;
 	}
 
 	function delete_node($nodeid){
 		$result = false;
-		$node_data = DBfetch(DBselect('select * from nodes where nodeid='.$nodeid));
+		$node_data = DBfetch(DBselect('select * from nodes where nodeid='.zbx_dbstr($nodeid)));
 
 		$node_type = detect_node_type($node_data);
 
@@ -335,8 +335,8 @@
 			$result = (
 				// DBexecute("insert into housekeeper (housekeeperid,tablename,field,value)".
 					// " values ($housekeeperid,'nodes','nodeid',$nodeid)") &&
-				DBexecute('delete from nodes where nodeid='.$nodeid) &&
-				DBexecute('update nodes set masterid=0 where masterid='.$nodeid)
+				DBexecute('delete from nodes where nodeid='.zbx_dbstr($nodeid)) &&
+				DBexecute('update nodes set masterid=0 where masterid='.zbx_dbstr($nodeid))
 				);
 			error(S_DATABASE_STILL_CONTAINS_DATA_RELATED_DELETED_NODE);
 		}
@@ -346,7 +346,7 @@
 
 	function get_node_by_nodeid($nodeid)
 	{
-		return DBfetch(DBselect('select * from nodes where nodeid='.$nodeid));
+		return DBfetch(DBselect('select * from nodes where nodeid='.zbx_dbstr($nodeid)));
 	}
 
 	function get_node_path($nodeid, $result='/')
Index: frontends/php/include/blocks.inc.php
===================================================================
--- frontends/php/include/blocks.inc.php	(revision 38884)
+++ frontends/php/include/blocks.inc.php	(working copy)
@@ -783,7 +783,7 @@
 		$event_sql = 'SELECT e.eventid, e.value, e.clock, e.objectid as triggerid, e.acknowledged'.
 					' FROM events e'.
 					' WHERE e.object='.EVENT_OBJECT_TRIGGER.
-						' AND e.objectid='.$trigger['triggerid'].
+						' AND e.objectid='.zbx_dbstr($trigger['triggerid']).
 						' AND e.value='.TRIGGER_VALUE_TRUE.
 					' ORDER by e.object DESC, e.objectid DESC, e.eventid DESC';
 		$res_events = DBSelect($event_sql,1);
@@ -876,7 +876,7 @@
 
 		$sql = 'SELECT DISTINCT ht.name, ht.httptestid, ht.curstate, ht.lastfailedstep '.
 				' FROM httptest ht, applications a, hosts_groups hg, groups g '.
-				' WHERE g.groupid='.$group['groupid'].
+				' WHERE g.groupid='.zbx_dbstr($group['groupid']).
 					' AND '.DBcondition('hg.hostid',$available_hosts).
 					' AND hg.groupid=g.groupid '.
 					' AND a.hostid=hg.hostid '.
Index: frontends/php/include/export.inc.php
===================================================================
--- frontends/php/include/export.inc.php	(revision 38884)
+++ frontends/php/include/export.inc.php	(working copy)
@@ -648,7 +648,7 @@
 
 // Deleteing all selements (with links)
 					$db_selementids = array();
-					$res = DBselect('SELECT selementid FROM sysmaps_elements WHERE sysmapid='.$sysmap['sysmapid']);
+					$res = DBselect('SELECT selementid FROM sysmaps_elements WHERE sysmapid='.zbx_dbstr($sysmap['sysmapid']));
 					while($db_selement = DBfetch($res)){
 						$db_selementids[$db_selement['selementid']] = $db_selement['selementid'];
 					}
Index: frontends/php/include/profiles.inc.php
===================================================================
--- frontends/php/include/profiles.inc.php	(revision 38884)
+++ frontends/php/include/profiles.inc.php	(working copy)
@@ -132,9 +132,9 @@
 			'profileid' => get_dbid('profiles', 'profileid'),
 			'userid' => $USER_DETAILS['userid'],
 			'idx' => zbx_dbstr($idx),
-			$value_type => ($value_type == 'value_str') ? zbx_dbstr($value) : $value,
-			'type' => $type,
-			'idx2' => $idx2
+			$value_type => zbx_dbstr($value),
+			'type' => zbx_dbstr($type),
+			'idx2' => zbx_dbstr($idx2)
 		);
 
 		$sql = 'INSERT INTO profiles ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
@@ -152,11 +152,10 @@
 		if($idx2 > 0) $sql_cond.= ' AND idx2='.$idx2.' AND '.DBin_node('idx2', false);
 		
 		$value_type = self::getFieldByType($type);
-		$value = ($value_type == 'value_str') ? zbx_dbstr($value) : $value;
 
 		$sql = 'UPDATE profiles SET '.
-					$value_type.'='.$value.','.
-					' type='.$type.
+					$value_type.'='.zbx_dbstr($value).','.
+					' type='.zbx_dbstr($type).
 				' WHERE userid='.$USER_DETAILS['userid'].
 					' AND idx='.zbx_dbstr($idx).
 					$sql_cond;
@@ -227,7 +226,7 @@
 		}
 	}
 	if(isset($configs['alert_usrgrpid']) && !is_null($configs['alert_usrgrpid'])){
-		if(($configs['alert_usrgrpid'] != 0) && !DBfetch(DBselect('select usrgrpid from usrgrp where usrgrpid='.$configs['alert_usrgrpid']))){
+		if(($configs['alert_usrgrpid'] != 0) && !DBfetch(DBselect('select usrgrpid from usrgrp where usrgrpid='.zbx_dbstr($configs['alert_usrgrpid'])))){
 			error(S_INCORRECT_GROUP);;
 			return NULL;
 		}
@@ -295,7 +294,7 @@
 	}
 
 	$sql = 'SELECT title5, url5
-			FROM user_history WHERE userid='.$userid;
+			FROM user_history WHERE userid='.zbx_dbstr($userid);
 	$history5 = DBfetch(DBSelect($sql));
 
 	if($history5 && ($history5['title5'] == $title)){ //title is same
@@ -373,7 +372,7 @@
 		'profileid' => get_dbid('profiles', 'profileid'),
 		'userid' => $USER_DETAILS['userid'],
 		'idx' => zbx_dbstr($favobj),
-		'value_id' =>  $favid,
+		'value_id' => zbx_dbstr($favid),
 		'type' => PROFILE_TYPE_ID
 	);
 	if(!is_null($source)) $values['source'] = zbx_dbstr($source);
@@ -393,7 +392,7 @@
 	$sql = 'DELETE FROM profiles '.
 		' WHERE userid='.$USER_DETAILS['userid'].
 			' AND idx='.zbx_dbstr($favobj).
-			(($favid > 0) ? ' AND value_id='.$favid : '').
+			(($favid > 0) ? ' AND value_id='.zbx_dbstr($favid) : '').
 			(is_null($source) ? '' : ' AND source='.zbx_dbstr($source));
 	
 	return DBexecute($sql);
Index: frontends/php/include/services.inc.php
===================================================================
--- frontends/php/include/services.inc.php	(revision 38884)
+++ frontends/php/include/services.inc.php	(working copy)
@@ -28,8 +28,6 @@
 			}
 		}
 
-		if(is_null($triggerid) || $triggerid==0) $triggerid = 'NULL';
-
 		$serviceid=get_dbid("services","serviceid");
 
 		remove_service_links($serviceid); //removes all links with current serviceid
@@ -45,19 +43,26 @@
 			return FALSE;
 		}
 
+		if (is_null($triggerid) || $triggerid==0) {
+			$triggerid = 'NULL';
+		}
+		else {
+			$triggerid = zbx_dbstr($triggerid);
+		}
+
 		$result=DBexecute('INSERT INTO services (serviceid,name,status,triggerid,algorithm,showsla,goodsla,sortorder)'.
 							' VALUES ('.$serviceid.','.zbx_dbstr($name).',0 ,'.$triggerid.' ,'.zbx_dbstr($algorithm).
-								' ,'.$showsla.','.zbx_dbstr($goodsla).','.$sortorder.')');
+								' ,'.zbx_dbstr($showsla).','.zbx_dbstr($goodsla).','.zbx_dbstr($sortorder).')');
 		if(!$result) return FALSE;
 
 		update_services_status_all(); // updating status to all services by the dependency
 
-		DBExecute('DELETE FROM services_times WHERE serviceid='.$serviceid);
+		DBExecute('DELETE FROM services_times WHERE serviceid='.zbx_dbstr($serviceid));
 
 		foreach($service_times as $val){
 			$timeid = get_dbid('services_times','timeid');
 			$result = DBexecute('INSERT INTO services_times (timeid, serviceid, type, ts_from, ts_to, note)'.
-				' values ('.$timeid.','.$serviceid.','.$val['type'].','.$val['from'].','.$val['to'].','.zbx_dbstr($val['note']).')');
+				' values ('.$timeid.','.$serviceid.','.zbx_dbstr($val['type']).','.zbx_dbstr($val['from']).','.zbx_dbstr($val['to']).','.zbx_dbstr($val['note']).')');
 
 			if(!$result)
 			{
@@ -86,21 +91,26 @@
 
 		if(!$result) return FALSE;
 
-		if(is_null($triggerid) || $triggerid==0) $triggerid = 'NULL';
+		if (is_null($triggerid) || $triggerid==0) {
+			$triggerid = 'NULL';
+		}
+		else {
+			$triggerid = zbx_dbstr($triggerid);
+		}
 
 		$result = DBexecute('UPDATE services '.
 							' SET name='.zbx_dbstr($name).
-								',triggerid='.$triggerid.', status=0, algorithm='.$algorithm.', '.
-								' showsla='.$showsla.', goodsla='.$goodsla.', sortorder='.$sortorder.
-							' WHERE serviceid='.$serviceid);
+								',triggerid='.$triggerid.', status=0, algorithm='.zbx_dbstr($algorithm).', '.
+								' showsla='.zbx_dbstr($showsla).', goodsla='.zbx_dbstr($goodsla).', sortorder='.zbx_dbstr($sortorder).
+							' WHERE serviceid='.zbx_dbstr($serviceid));
 
 		update_services_status_all(); // updating status to all services by the dependency
 
-		DBexecute('DELETE FROM services_times WHERE serviceid='.$serviceid);
+		DBexecute('DELETE FROM services_times WHERE serviceid='.zbx_dbstr($serviceid));
 		foreach($service_times as $val){
 			$timeid = get_dbid('services_times','timeid');
 			DBexecute('INSERT INTO services_times (timeid,serviceid, type, ts_from, ts_to, note)'.
-				' VALUES('.$timeid.','.$serviceid.','.$val['type'].','.$val['from'].','.$val['to'].','.zbx_dbstr($val['note']).')');
+				' VALUES('.$timeid.','.zbx_dbstr($serviceid).','.zbx_dbstr($val['type']).','.zbx_dbstr($val['from']).','.zbx_dbstr($val['to']).','.zbx_dbstr($val['note']).')');
 		}
 
 		return $result;
@@ -109,7 +119,7 @@
 	function	add_host_to_services($hostid, $serviceid){
 		$result = DBselect('SELECT distinct h.host,t.triggerid,t.description,t.expression '.
 							' FROM triggers t,hosts h,items i,functions f '.
-							' WHERE h.hostid='.$hostid.
+							' WHERE h.hostid='.zbx_dbstr($hostid).
 								' AND h.hostid=i.hostid '.
 								' AND i.itemid=f.itemid '.
 								' AND f.triggerid=t.triggerid '.
@@ -124,7 +134,7 @@
 	}
 
 	function	is_service_hardlinked($serviceid){
-		$row = DBfetch(DBselect("SELECT count(*) as cnt FROM services_links WHERE servicedownid=".$serviceid." and soft=0"));
+		$row = DBfetch(DBselect("SELECT count(*) as cnt FROM services_links WHERE servicedownid=".zbx_dbstr($serviceid)." and soft=0"));
 		if($row["cnt"]>0)
 		{
 			return	TRUE;
@@ -156,7 +166,7 @@
 
 			$sql = 'SELECT s.status'.
 					' FROM services s,services_links l '.
-					' WHERE l.serviceupid='.$serviceid.
+					' WHERE l.serviceupid='.zbx_dbstr($serviceid).
 						' AND s.serviceid=l.servicedownid '.
 					' ORDER BY s.status '.$sort_order;
 			$result = DBselect($sql);
@@ -175,16 +185,16 @@
 	 *                                                                            *
 	 ******************************************************************************/
 	function	delete_service($serviceid){
-		$sql="DELETE FROM services_links WHERE servicedownid=$serviceid OR serviceupid=$serviceid";
+		$sql="DELETE FROM services_links WHERE servicedownid=".zbx_dbstr($serviceid)." OR serviceupid=".zbx_dbstr($serviceid);
 		if(!$result=DBexecute($sql)) return	$result;
 
-		$sql="DELETE FROM services WHERE serviceid=$serviceid";
+		$sql="DELETE FROM services WHERE serviceid=".zbx_dbstr($serviceid);
 		if(!$result=DBexecute($sql)) return	$result;
 
-		$sql="DELETE FROM service_alarms WHERE serviceid=$serviceid";
+		$sql="DELETE FROM service_alarms WHERE serviceid=".zbx_dbstr($serviceid);
 		if(!$result=DBexecute($sql)) return	$result;
 
-		$sql="DELETE FROM services_times WHERE serviceid=$serviceid";
+		$sql="DELETE FROM services_times WHERE serviceid=".zbx_dbstr($serviceid);
 		if(!$result=DBexecute($sql)) return	$result;
 
 		update_services_status_all();
@@ -209,7 +219,7 @@
 		if($serviceid != 0){
 			$sql='UPDATE services '.
 					' SET triggerid = null '.
-					' WHERE serviceid = '.$serviceid;
+					' WHERE serviceid = '.zbx_dbstr($serviceid);
 			DBexecute($sql);
 		return;
 		}
@@ -224,7 +234,7 @@
 		while($rows = DBfetch($res)){
 			$sql='UPDATE services '.
 					' SET triggerid = null '.
-					' WHERE serviceid = '.$rows['serviceid'];
+					' WHERE serviceid = '.zbx_dbstr($rows['serviceid']);
 			DBexecute($sql);
 		}
 	}
@@ -243,7 +253,7 @@
 
 		}
 
-		$result=DBselect("SELECT serviceupid FROM services_links WHERE servicedownid=$serviceid2 and soft=0");
+		$result=DBselect("SELECT serviceupid FROM services_links WHERE servicedownid=".zbx_dbstr($serviceid2)." and soft=0");
 		while($row=DBfetch($result)){
 			if(does_service_depend_on_the_service($serviceid,$row["serviceupid"]) == TRUE){
 				return	TRUE;
@@ -253,7 +263,7 @@
 	}
 
 	function service_has_parent($serviceid){
-		$row = DBfetch(DBselect('SELECT linkid FROM services_links WHERE servicedownid='.$serviceid));
+		$row = DBfetch(DBselect('SELECT linkid FROM services_links WHERE servicedownid='.zbx_dbstr($serviceid)));
 		if($row && !zbx_empty($row['linkid'])){
 			return	TRUE;
 		}
@@ -262,7 +272,7 @@
 
 // Seems not used ant more!
 	function service_has_no_this_parent($parentid,$serviceid){
-		$row = DBfetch(DBselect('SELECT linkid FROM services_links WHERE serviceupid='.$parentid.' AND servicedownid='.$serviceid));
+		$row = DBfetch(DBselect('SELECT linkid FROM services_links WHERE serviceupid='.zbx_dbstr($parentid).' AND servicedownid='.zbx_dbstr($serviceid)));
 		if($row && !zbx_empty($row['linkid'])){
 			return	FALSE;
 		}
@@ -282,7 +292,7 @@
 
 		$linkid=get_dbid("services_links","linkid");
 
-		$sql="INSERT INTO services_links (linkid,servicedownid,serviceupid,soft) values ($linkid,$servicedownid,$serviceupid,$softlink)";
+		$sql="INSERT INTO services_links (linkid,servicedownid,serviceupid,soft) values ($linkid,".zbx_dbstr($servicedownid).",".zbx_dbstr($serviceupid).",".zbx_dbstr($softlink).")";
 		$result=DBexecute($sql);
 
 		if(!$result)
@@ -301,27 +311,27 @@
 			return	false;
 		}
 
-		$sql="UPDATE services_links SET servicedownid=$servicedownid, serviceupid=$serviceupid, soft=$softlink WHERE linkid=$linkid";
+		$sql="UPDATE services_links SET servicedownid=".zbx_dbstr($servicedownid).", serviceupid=".zbx_dbstr($serviceupid).", soft=".zbx_dbstr($softlink)." WHERE linkid=".zbx_dbstr($linkid);
 		return	dbexecute($sql);
 	}
 
 	function remove_service_links($serviceid){
 		$query='DELETE
 				FROM services_links
-				WHERE serviceupid='.$serviceid.'
-					OR  (servicedownid='.$serviceid.'
+				WHERE serviceupid='.zbx_dbstr($serviceid).'
+					OR  (servicedownid='.zbx_dbstr($serviceid).'
 					AND soft<>1)';
 		DBExecute($query);
 	}
 
 	function get_last_service_value($serviceid,$clock){
-	       	$sql="SELECT count(*) as cnt,max(clock) as maxx FROM service_alarms WHERE serviceid=$serviceid and clock<=$clock";
+	       	$sql="SELECT count(*) as cnt,max(clock) as maxx FROM service_alarms WHERE serviceid=".zbx_dbstr($serviceid)." and clock<=".zbx_dbstr($clock);
 //		echo " $sql<br>";
 
 	        $result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row["cnt"]>0){
-	       		$sql="SELECT value FROM service_alarms WHERE serviceid=$serviceid and clock=".$row["maxx"];
+	       		$sql="SELECT value FROM service_alarms WHERE serviceid=".zbx_dbstr($serviceid)." and clock=".zbx_dbstr($row["maxx"]);
 		        $result2=DBselect($sql);
 // Assuring that we get very latest service value. There could be several with the same timestamp
 //			$value=DBget_field($result2,0,0);
@@ -408,9 +418,9 @@
 /* sort by time stamp */
 		$sql = 'SELECT sa.servicealarmid, sa.clock, sa.value '.
 				' FROM service_alarms sa '.
-				' WHERE sa.serviceid='.$serviceid.
-					' AND sa.clock>='.$period_start.
-					' AND sa.clock<='.$period_end.
+				' WHERE sa.serviceid='.zbx_dbstr($serviceid).
+					' AND sa.clock>='.zbx_dbstr($period_start).
+					' AND sa.clock<='.zbx_dbstr($period_end).
 				' ORDER BY sa.clock asc, sa.servicealarmid asc';
 		$service_alarms = DBselect($sql);
 		while($db_alarm_row = DBfetch($service_alarms)){
@@ -421,7 +431,7 @@
 		$sql = 'SELECT st.ts_from, st.ts_to '.
 				' FROM services_times st'.
 				' WHERE st.type='.SERVICE_TIME_TYPE_UPTIME.
-					' AND st.serviceid='.$serviceid;
+					' AND st.serviceid='.zbx_dbstr($serviceid);
 		$service_times = DBselect($sql);
 		if($db_time_row = DBfetch($service_times)){
 // if exist any uptime - unmarked time is downtime
@@ -440,7 +450,7 @@
 		$sql = 'SELECT ts_from,ts_to '.
 				' FROM services_times '.
 				' WHERE type='.SERVICE_TIME_TYPE_DOWNTIME.
-					' AND serviceid='.$serviceid;
+					' AND serviceid='.zbx_dbstr($serviceid);
 		$service_times = DBselect($sql);
 		while($db_time_row = DBfetch($service_times)){
 			expand_periodical_service_times($data,$period_start, $period_end,$db_time_row['ts_from'], $db_time_row['ts_to'],'dt');
@@ -450,7 +460,7 @@
 		$sql = 'SELECT ts_from,ts_to '.
 				' FROM services_times '.
 				' WHERE type='.SERVICE_TIME_TYPE_ONETIME_DOWNTIME.
-					' AND serviceid='.$serviceid;
+					' AND serviceid='.zbx_dbstr($serviceid);
 		$service_times = DBselect($sql);
 		while($db_time_row = DBfetch($service_times)){
 
@@ -587,13 +597,13 @@
 
 	function get_num_of_service_childs($serviceid){
 		$row = DBfetch(DBselect("SELECT count(distinct servicedownid) as cnt FROM services_links ".
-					" WHERE serviceupid=".$serviceid));
+					" WHERE serviceupid=".zbx_dbstr($serviceid)));
 	return	$row["cnt"];
 	}
 
 	function	get_service_by_serviceid($serviceid)
 	{
-		$res = DBfetch(DBselect("SELECT * FROM services WHERE serviceid=".$serviceid));
+		$res = DBfetch(DBselect("SELECT * FROM services WHERE serviceid=".zbx_dbstr($serviceid)));
 		if(!$res)
 		{
 			error(S_NO_SERVICE_WITH." serviceid=[".$serviceid."]");
@@ -603,7 +613,7 @@
 	}
 
 	function	get_services_links_by_linkid($linkid){
-		$result=DBselect("SELECT * FROM services_links WHERE linkid=$linkid");
+		$result=DBselect("SELECT * FROM services_links WHERE linkid=".zbx_dbstr($linkid));
 		$res = DBfetch($result);
 		if(!$res){
 			error(S_NO_SERVICE_LINKAGE_WITH." linkid=[$linkid]");
@@ -630,7 +640,7 @@
 
 		$query = 'SELECT sl.servicedownid '.
 			' FROM services_links sl '.
-			' WHERE sl.serviceupid = '.$serviceid.($soft?'':' AND sl.soft <> 1');
+			' WHERE sl.serviceupid = '.zbx_dbstr($serviceid).($soft?'':' AND sl.soft <> 1');
 
 		$res =  DBSelect($query);
 		while($row = DBFetch($res)){
@@ -741,7 +751,7 @@
 	$result = DBselect('SELECT l.serviceupid,s.algorithm '.
 						' FROM services_links l,services s '.
 						' WHERE s.serviceid=l.serviceupid '.
-							' AND l.servicedownid='.$serviceid
+							' AND l.servicedownid='.zbx_dbstr($serviceid)
 						);
 
 	while($rows=DBfetch($result)){
@@ -756,7 +766,7 @@
 			$status = get_service_status($serviceupid,$algorithm);
 
 			add_service_alarm($serviceupid,$status,time());
-			DBexecute('UPDATE services SET status='.$status.' WHERE serviceid='.$serviceupid);
+			DBexecute('UPDATE services SET status='.zbx_dbstr($status).' WHERE serviceid='.zbx_dbstr($serviceupid));
 		}
 		else{
 			error(S_UNKNOWN_CALC_ALGORITHM_OF_SERVICE_STATUS.SPACE.'['.$algorithm.']');
@@ -764,7 +774,7 @@
 		}
 	}
 
-	$result = DBselect('SELECT serviceupid FROM services_links WHERE servicedownid='.$serviceid);
+	$result = DBselect('SELECT serviceupid FROM services_links WHERE servicedownid='.zbx_dbstr($serviceid));
 
 	while($rows=DBfetch($result)){
 		$serviceupid =  $rows['serviceupid'];
@@ -790,9 +800,9 @@
  *                                                                            *
  ******************************************************************************/
 function update_services($triggerid, $status){
-	DBexecute('UPDATE services SET status='.$status.' WHERE triggerid='.$triggerid);
+	DBexecute('UPDATE services SET status='.zbx_dbstr($status).' WHERE triggerid='.zbx_dbstr($triggerid));
 
-	$result = DBselect('SELECT serviceid,algorithm FROM services WHERE triggerid='.$triggerid);
+	$result = DBselect('SELECT serviceid,algorithm FROM services WHERE triggerid='.zbx_dbstr($triggerid));
 
 	while(($rows=DBfetch($result))){
 //		$status = get_service_status($rows['serviceid'],$rows['algorithm'],$triggerid);
@@ -825,7 +835,7 @@
 
 	while($rows=DBfetch($result)){
 		$status = get_service_status($rows['serviceid'],$rows['algorithm'],$rows['triggerid']);
-		DBexecute('UPDATE services SET status = '.$status.' WHERE serviceid='.$rows['serviceid']);
+		DBexecute('UPDATE services SET status = '.zbx_dbstr($status).' WHERE serviceid='.zbx_dbstr($rows['serviceid']));
 
 		add_service_alarm($rows['serviceid'],$status,time());
 	}
@@ -850,7 +860,7 @@
 
 	$result = DBselect('SELECT servicealarmid, value '.
 						' FROM service_alarms '.
-						' WHERE serviceid='.$serviceid.
+						' WHERE serviceid='.zbx_dbstr($serviceid).
 						' ORDER BY servicealarmid DESC',1);
 	$rows = DBfetch($result);
 	if($rows && !is_null($rows['value']) && ($rows['value'] == $status)){
@@ -870,7 +880,7 @@
 		return true;
 	}
 
-	$result = DBexecute('INSERT INTO service_alarms (servicealarmid,serviceid,clock,value) VALUES ('.get_dbid('service_alarms','servicealarmid').','.$serviceid.','.$clock.','.$status.')');
+	$result = DBexecute('INSERT INTO service_alarms (servicealarmid,serviceid,clock,value) VALUES ('.get_dbid('service_alarms','servicealarmid').','.zbx_dbstr($serviceid).','.zbx_dbstr($clock).','.zbx_dbstr($status).')');
 
 	return $result;
 }
Index: frontends/php/include/graphs.inc.php
===================================================================
--- frontends/php/include/graphs.inc.php	(revision 38884)
+++ frontends/php/include/graphs.inc.php	(working copy)
@@ -121,7 +121,7 @@
 
 		$sql = 'SELECT MAX(g.graphtype) as graphtype, MIN(gi.yaxisside) as yaxissidel, MAX(gi.yaxisside) as yaxissider, MAX(g.height) as height'.
 				' FROM graphs g, graphs_items gi '.
-				' WHERE g.graphid='.$graphid.
+				' WHERE g.graphid='.zbx_dbstr($graphid).
 					' AND gi.graphid=g.graphid ';
 		$res = DBselect($sql);
 		if($graph=DBfetch($res)){
@@ -154,7 +154,7 @@
 		$db_graphs = DBselect('SELECT distinct g.* '.
 						' FROM graphs g, graphs_items gi '.
 						' WHERE g.graphid=gi.graphid '.
-							' AND gi.gitemid='.$gitemid);
+							' AND gi.gitemid='.zbx_dbstr($gitemid));
 
 	return DBfetch($db_graphs);
 	}
@@ -164,7 +164,7 @@
 				' FROM graphs g, graphs_items gi, items i '.
 				' WHERE g.graphid=gi.graphid '.
 					' AND gi.itemid=i.itemid '.
-					' AND i.hostid='.$hostid;
+					' AND i.hostid='.zbx_dbstr($hostid);
 	return DBselect($sql);
 	}
 
@@ -181,13 +181,13 @@
 							' FROM graphs_items gi, items i, hosts h'.
 							' WHERE h.hostid=i.hostid '.
 								' AND gi.itemid=i.itemid '.
-								' AND gi.graphid='.$graphid);
+								' AND gi.graphid='.zbx_dbstr($graphid));
 	}
 
 	function get_graphitems_by_graphid($graphid){
 		return DBselect('SELECT * '.
 					' FROM graphs_items '.
-					' WHERE graphid='.$graphid.
+					' WHERE graphid='.zbx_dbstr($graphid).
 					' ORDER BY itemid,drawtype,sortorder,color,yaxisside');
 	}
 
@@ -207,7 +207,7 @@
 
 		$sql = 	'SELECT g.graphid '.
 				' FROM graphs g, graphs_items gi, items i '.
-				' WHERE g.graphid='.$graphid.
+				' WHERE g.graphid='.zbx_dbstr($graphid).
 					' AND g.graphid=gi.graphid '.
 					' AND i.itemid=gi.itemid '.
 					' AND '.DBcondition('i.hostid',$available_hosts,true);
@@ -302,7 +302,7 @@
 		$itemids = array();
 		$sql = 'SELECT DISTINCT gi.itemid '.
 				' FROM graphs_items gi '.
-				' WHERE gi.graphid='.$graphid;
+				' WHERE gi.graphid='.zbx_dbstr($graphid);
 		$res = DBselect($sql);
 		while($item = DBfetch($res)){
 			$itemids[$item['itemid']] = $item['itemid'];
@@ -389,7 +389,7 @@
 	}
 
 	function get_graphitem_by_gitemid($gitemid){
-		$result=DBselect('SELECT * FROM graphs_items WHERE gitemid='.$gitemid);
+		$result=DBselect('SELECT * FROM graphs_items WHERE gitemid='.zbx_dbstr($gitemid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -400,7 +400,7 @@
 	}
 
 	function get_graphitem_by_itemid($itemid){
-		$result = DBfetch(DBselect('SELECT * FROM graphs_items WHERE itemid='.$itemid));
+		$result = DBfetch(DBselect('SELECT * FROM graphs_items WHERE itemid='.zbx_dbstr($itemid)));
 		$row=DBfetch($result);
 		if($row)
 		{
@@ -411,7 +411,7 @@
 
 	function get_graph_by_graphid($graphid){
 
-		$result=DBselect("SELECT * FROM graphs WHERE graphid=$graphid");
+		$result=DBselect('SELECT * FROM graphs WHERE graphid='.zbx_dbstr($graphid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -444,9 +444,9 @@
 		foreach($gitems as $gitem){
 			$sql = 'SELECT src.itemid, dest.key_ '.
 					' FROM items src, items dest '.
-					' WHERE dest.itemid='.$gitem['itemid'].
+					' WHERE dest.itemid='.zbx_dbstr($gitem['itemid']).
 						' AND src.key_=dest.key_ '.
-						' AND src.hostid='.$dest_hostid;
+						' AND src.hostid='.zbx_dbstr($dest_hostid);
 			$db_item = DBfetch(DBselect($sql));
 			if (!$db_item && $error){
 				$item = get_item_by_itemid($gitem['itemid']);
@@ -487,8 +487,11 @@
 
 		$result=DBexecute('INSERT INTO graphs '.
 			' (graphid,name,width,height,ymin_type,ymax_type,yaxismin,yaxismax,ymin_itemid,ymax_itemid,templateid,show_work_period,show_triggers,graphtype,show_legend,show_3d,percent_left,percent_right) '.
-			" VALUES ($graphid,".zbx_dbstr($name).",$width,$height,$ymin_type,$ymax_type,$yaxismin,$yaxismax,$ymin_itemid,$ymax_itemid,".
-			" $templateid,$showworkperiod,$showtriggers,$graphtype,$legend,$graph3d,$percent_left,$percent_right)");
+			' VALUES ('.$graphid.','.zbx_dbstr($name).','.zbx_dbstr($width).','.zbx_dbstr($height).','.
+				zbx_dbstr($ymin_type).','.zbx_dbstr($ymax_type).','.zbx_dbstr($yaxismin).','.zbx_dbstr($yaxismax).','.
+				zbx_dbstr($ymin_itemid).','.zbx_dbstr($ymax_itemid).','.zbx_dbstr($templateid).','.
+				zbx_dbstr($showworkperiod).','.zbx_dbstr($showtriggers).','.zbx_dbstr($graphtype).','.zbx_dbstr($legend).','.
+				zbx_dbstr($graph3d).','.zbx_dbstr($percent_left).','.zbx_dbstr($percent_right));
 
 		return ( $result ? $graphid : $result);
 	}
@@ -608,28 +611,28 @@
 
 		$sql = 'UPDATE graphs SET '.
 				'name='.zbx_dbstr($name).','.
-				'width='.$width.','.
-				'height='.$height.','.
-				'ymin_type='.$ymin_type.','.
-				'ymax_type='.$ymax_type.','.
-				'yaxismin='.$yaxismin.','.
-				'yaxismax='.$yaxismax.','.
-				'ymin_itemid='.$ymin_itemid.','.
-				'ymax_itemid='.$ymax_itemid.','.
-				'templateid='.$templateid.','.
-				'show_work_period='.$showworkperiod.','.
-				'show_triggers='.$showtriggers.','.
-				'graphtype='.$graphtype.','.
-				'show_legend='.$legend.','.
-				'show_3d='.$graph3d.','.
-				'percent_left='.$percent_left.','.
-				'percent_right='.$percent_right.
-			' WHERE graphid='.$graphid;
+				'width='.zbx_dbstr($width).','.
+				'height='.zbx_dbstr($height).','.
+				'ymin_type='.zbx_dbstr($ymin_type).','.
+				'ymax_type='.zbx_dbstr($ymax_type).','.
+				'yaxismin='.zbx_dbstr($yaxismin).','.
+				'yaxismax='.zbx_dbstr($yaxismax).','.
+				'ymin_itemid='.zbx_dbstr($ymin_itemid).','.
+				'ymax_itemid='.zbx_dbstr($ymax_itemid).','.
+				'templateid='.zbx_dbstr($templateid).','.
+				'show_work_period='.zbx_dbstr($showworkperiod).','.
+				'show_triggers='.zbx_dbstr($showtriggers).','.
+				'graphtype='.zbx_dbstr($graphtype).','.
+				'show_legend='.zbx_dbstr($legend).','.
+				'show_3d='.zbx_dbstr($graph3d).','.
+				'percent_left='.zbx_dbstr($percent_left).','.
+				'percent_right='.zbx_dbstr($percent_right).
+			' WHERE graphid='.zbx_dbstr($graphid);
 
 		if($result = DBexecute($sql)){
 			if($g_graph['graphtype'] != $graphtype && $graphtype == GRAPH_TYPE_STACKED){
 				$result = DBexecute('UPDATE graphs_items SET calc_fnc='.CALC_FNC_AVG.',drawtype=1,type='.GRAPH_ITEM_SIMPLE.
-					' WHERE graphid='.$graphid);
+					' WHERE graphid='.zbx_dbstr($graphid));
 			}
 		}
 		return $result;
@@ -701,7 +704,7 @@
 			}
 		}
 
-		DBexecute('DELETE FROM graphs_items WHERE graphid='.$graphid);
+		DBexecute('DELETE FROM graphs_items WHERE graphid='.zbx_dbstr($graphid));
 
 		foreach($gitems as $gitem){
 			if (!$result = add_item_to_graph(
@@ -833,8 +836,8 @@
 
 		$result = DBexecute('insert into graphs_items'.
 			' (gitemid,graphid,itemid,color,drawtype,sortorder,yaxisside,calc_fnc,type,periods_cnt)'.
-			' values ('.$gitemid.','.$graphid.','.$itemid.','.zbx_dbstr($color).','.$drawtype.','.
-			$sortorder.','.$yaxisside.','.$calc_fnc.','.$type.','.$periods_cnt.')');
+			' values ('.$gitemid.','.zbx_dbstr($graphid).','.zbx_dbstr($itemid).','.zbx_dbstr($color).','.zbx_dbstr($drawtype).','.
+			zbx_dbstr($sortorder).','.zbx_dbstr($yaxisside).','.zbx_dbstr($calc_fnc).','.zbx_dbstr($type).','.zbx_dbstr($periods_cnt).')');
 
 		return ( $result ? $gitemid : $result );
 	}
Index: frontends/php/include/db.inc.php
===================================================================
--- frontends/php/include/db.inc.php	(revision 38884)
+++ frontends/php/include/db.inc.php	(working copy)
@@ -846,7 +846,7 @@
 			default:
 				$items = array_chunk($array, 950);
 				foreach($items as $id => $values){
-					if($string) $values = zbx_dbstr($values);
+					$values = zbx_dbstr($values);
 
 					$condition.=!empty($condition)?')'.$concat.$fieldname.$in.'(':'';
 					$condition.= implode(',',$values);
